
module CodeBuildTail
  class Build
    attr_reader :build_id, :build, :refresh_count
    def initialize(client, build_id)
      @refresh_count = 0
      @client = client
      @build_id = build_id
    end

    def logs
      @build.logs
    end

    def missing?
      @build.nil?
    end

    def running?
      @build.build_status == "IN_PROGRESS"
    end

    def successful?
      @build.build_status == "SUCCEEDED"
    end

    def refresh
      response = @client.batch_get_builds({ ids: [@build_id] })
      @refresh_count += 1
      @build = if response[:builds].empty?
                 nil
               else
                 response[:builds][0]
               end
    end
  end
end
